program Conv

  use sep
  use separate_mod 

  implicit none

  integer                            :: n1, n2, npad
  real                               :: o1, d1, o2, d2, dist1, dist2
  real, dimension(:,:), allocatable  :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  call from_param("dist1", dist1)
  call from_param("dist2", dist2)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  allocate( data(n1,n2) )

  data = 0.

  call separate_init(n1, n2, d1, d2, dist1, dist2)

  call sep_read(data)

  call separate_smooth(data)

  call sep_write(data)

  call sep_close()

end program
