program Himage

  use sep

  implicit none

  integer                              :: n1, n2, n3, j, k
  real                                 :: o1, d1, o2, d2, o3, d3, sou_x, rec_x, offset0, offset1
  real, dimension(:,:), allocatable    :: offset
  real, dimension(:,:,:), allocatable  :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  allocate(data(n1,n2,n3))
  allocate(offset(n2,n3))

  call sep_read(data)

  do k=1,n3
    sou_x = o3 + (k-1)*d3
    do j=1,n2
      rec_x = o2 + (j-1)*d2
      offset(j,k) = rec_x - sou_x
    enddo
  end do

  offset = abs(offset)
  offset1 = maxval(offset(:,(n3+1)/2))
  offset0 = offset1/2.

  do k=1,n3
    do j=1,n2
      if(offset(j,k) > offset1) then
        data(:,j,k) = 0.
      elseif(offset(j,k) > offset0 .and. offset(j,k) <= offset1 ) then
        data(:,j,k) = data(:,j,k)*(offset1-offset(j,k))/(offset1-offset0)
      endif
    enddo
  end do

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call sep_write(data)

  call sep_close()
end program
